#include <math.h>

void getRBConGradientOPTBasic (
  double tK,
  double bKw,
  double bKh,
  double hL0,
	const double *iniMatTanRB,
	const double *iniMatNorRB,
	const double *iniRefTanRO,
	const double *iniRefNorRO,
  double rtx,
	const double *rotationAnglesRB,
	const double *ex,
  double thetax,
  double *energyGradient)
{
  double t1;
  double t10;
  double t100;
  double t1001;
  double t1004;
  double t1009;
  double t101;
  double t1012;
  double t102;
  double t1022;
  double t1025;
  double t1029;
  double t1033;
  double t1035;
  double t1039;
  double t104;
  double t1044;
  double t1049;
  double t1058;
  double t106;
  double t107;
  double t1070;
  double t108;
  double t1084;
  double t1087;
  double t11;
  double t1100;
  double t1103;
  double t1116;
  double t112;
  double t1122;
  double t1135;
  double t1156;
  double t1159;
  double t116;
  double t1173;
  double t1178;
  double t1187;
  double t119;
  double t1196;
  double t12;
  double t1209;
  double t1218;
  double t122;
  double t126;
  double t1260;
  double t1266;
  double t127;
  double t1272;
  double t1275;
  double t1279;
  double t1285;
  double t1289;
  double t129;
  double t1292;
  double t1295;
  double t1299;
  double t13;
  double t1305;
  double t131;
  double t1313;
  double t1318;
  double t1319;
  double t132;
  double t133;
  double t1330;
  double t1332;
  double t1343;
  double t1349;
  double t1355;
  double t1358;
  double t136;
  double t1369;
  double t137;
  double t1370;
  double t1377;
  double t138;
  double t1380;
  double t1385;
  double t139;
  double t1398;
  double t14;
  double t1404;
  double t141;
  double t1410;
  double t143;
  double t1437;
  double t1439;
  double t1442;
  double t1449;
  double t1453;
  double t1455;
  double t1458;
  double t146;
  double t1461;
  double t1464;
  double t1466;
  double t1468;
  double t1474;
  double t1479;
  double t148;
  double t1485;
  double t1490;
  double t1496;
  double t15;
  double t1504;
  double t1509;
  double t1521;
  double t153;
  double t1534;
  double t1546;
  double t1549;
  double t155;
  double t1560;
  double t1571;
  double t1589;
  double t1595;
  double t16;
  double t160;
  double t1601;
  double t1629;
  double t1630;
  double t1633;
  double t1637;
  double t1639;
  double t1644;
  double t1646;
  double t1650;
  double t1655;
  double t1661;
  double t1673;
  double t168;
  double t1687;
  double t169;
  double t1699;
  double t17;
  double t1702;
  double t1713;
  double t172;
  double t1724;
  double t1742;
  double t1749;
  double t1756;
  double t1786;
  double t1789;
  double t1796;
  double t18;
  double t180;
  double t1808;
  double t183;
  double t193;
  double t199;
  double t2;
  double t20;
  double t209;
  double t211;
  double t215;
  double t216;
  double t219;
  double t22;
  double t221;
  double t222;
  double t223;
  double t225;
  double t226;
  double t229;
  double t23;
  double t230;
  double t231;
  double t233;
  double t234;
  double t235;
  double t237;
  double t238;
  double t241;
  double t243;
  double t244;
  double t247;
  double t250;
  double t251;
  double t256;
  double t259;
  double t260;
  double t263;
  double t265;
  double t267;
  double t271;
  double t274;
  double t275;
  double t277;
  double t285;
  double t287;
  double t288;
  double t29;
  double t290;
  double t293;
  double t294;
  double t296;
  double t297;
  double t299;
  double t3;
  double t300;
  double t303;
  double t306;
  double t307;
  double t310;
  double t313;
  double t314;
  double t317;
  double t319;
  double t320;
  double t325;
  double t327;
  double t328;
  double t329;
  double t333;
  double t335;
  double t337;
  double t345;
  double t348;
  double t350;
  double t358;
  double t363;
  double t367;
  double t37;
  double t371;
  double t375;
  double t379;
  double t385;
  double t386;
  double t39;
  double t391;
  double t394;
  double t396;
  double t4;
  double t40;
  double t404;
  double t407;
  double t41;
  double t413;
  double t416;
  double t418;
  double t42;
  double t425;
  double t427;
  double t428;
  double t43;
  double t433;
  double t437;
  double t44;
  double t440;
  double t446;
  double t450;
  double t457;
  double t459;
  double t46;
  double t460;
  double t463;
  double t465;
  double t466;
  double t467;
  double t47;
  double t470;
  double t480;
  double t486;
  double t487;
  double t489;
  double t49;
  double t497;
  double t498;
  double t499;
  double t5;
  double t502;
  double t509;
  double t510;
  double t512;
  double t515;
  double t52;
  double t522;
  double t523;
  double t525;
  double t528;
  double t533;
  double t537;
  double t538;
  double t542;
  double t547;
  double t55;
  double t553;
  double t557;
  double t56;
  double t561;
  double t565;
  double t569;
  double t57;
  double t570;
  double t575;
  double t58;
  double t581;
  double t582;
  double t588;
  double t59;
  double t592;
  double t598;
  double t6;
  double t601;
  double t604;
  double t61;
  double t611;
  double t612;
  double t615;
  double t618;
  double t62;
  double t622;
  double t628;
  double t63;
  double t644;
  double t647;
  double t65;
  double t652;
  double t66;
  double t661;
  double t675;
  double t68;
  double t680;
  double t682;
  double t683;
  double t686;
  double t689;
  double t692;
  double t693;
  double t699;
  double t7;
  double t701;
  double t702;
  double t707;
  double t712;
  double t72;
  double t720;
  double t723;
  double t728;
  double t729;
  double t732;
  double t733;
  double t737;
  double t74;
  double t740;
  double t743;
  double t748;
  double t75;
  double t753;
  double t764;
  double t769;
  double t77;
  double t777;
  double t78;
  double t790;
  double t794;
  double t797;
  double t8;
  double t80;
  double t803;
  double t811;
  double t814;
  double t82;
  double t821;
  double t83;
  double t830;
  double t838;
  double t84;
  double t85;
  double t851;
  double t853;
  double t854;
  double t87;
  double t875;
  double t89;
  double t890;
  double t894;
  double t898;
  double t899;
  double t9;
  double t90;
  double t902;
  double t911;
  double t92;
  double t920;
  double t927;
  double t932;
  double t94;
  double t941;
  double t944;
  double t95;
  double t952;
  double t96;
  double t98;
  double t989;
  double t99;
  double t993;
  double t997;
  t9 = ex[0];
  t1 = t9 * t9;
  t12 = ex[1];
  t2 = t12 * t12;
  t15 = ex[2];
  t3 = t15 * t15;
  t4 = t1 + t2 + t3;
  t5 = sqrt(t4);
  t6 = 0.1e1 / t5;
  t7 = t6 * t12;
  t18 = iniRefTanRO[0];
  t8 = t18 * t6;
  t10 = 0.1e1 * t8 * t9;
  t20 = iniRefTanRO[1];
  t11 = t20 * t6;
  t13 = 0.1e1 * t11 * t12;
  t22 = iniRefTanRO[2];
  t14 = t22 * t6;
  t16 = 0.1e1 * t14 * t15;
  t17 = t10 + t13 + t16;
  t23 = 0.1e1 * t11 * t15 - 0.1e1 * t14 * t12;
  t29 = -0.1e1 * t8 * t15 + 0.1e1 * t14 * t9;
  t37 = 0.1e1 * t8 * t12 - 0.1e1 * t11 * t9;
  t43 = iniRefNorRO[0];
  t46 = iniRefNorRO[1];
  t49 = iniRefNorRO[2];
  t39 = t23 * t43 + t29 * t46 + t37 * t49;
  t40 = 0.1e1 + t10 + t13 + t16;
  t41 = 0.1e1 / t40;
  t42 = t39 * t41;
  t44 = t17 * t49 + t23 * t46 - t29 * t43 + t37 * t42;
  t47 = t6 * t15;
  t52 = t17 * t46 - t23 * t49 + t29 * t42 + t37 * t43;
  t55 = 0.1e1 * t7 * t44 - 0.1e1 * t47 * t52;
  t56 = cos(rtx);
  t82 = rotationAnglesRB[2];
  t57 = cos(t82);
  t84 = rotationAnglesRB[1];
  t58 = cos(t84);
  t59 = t57 * t58;
  t61 = sin(t84);
  t62 = t57 * t61;
  t85 = rotationAnglesRB[0];
  t63 = sin(t85);
  t65 = sin(t82);
  t66 = cos(t85);
  t68 = t62 * t63 - t65 * t66;
  t72 = t62 * t66 + t63 * t65;
  t95 = iniMatTanRB[0];
  t100 = iniMatTanRB[1];
  t104 = iniMatTanRB[2];
  t74 = t100 * t68 + t104 * t72 + t59 * t95;
  t75 = t74 * t6;
  t77 = 0.1e1 * t75 * t9;
  t78 = t65 * t58;
  t80 = t65 * t61;
  t83 = t57 * t66 + t63 * t80;
  t87 = -t57 * t63 + t66 * t80;
  t89 = t100 * t83 + t104 * t87 + t78 * t95;
  t90 = t89 * t6;
  t92 = 0.1e1 * t90 * t12;
  t94 = t58 * t63;
  t96 = t58 * t66;
  t98 = t100 * t94 + t104 * t96 - t61 * t95;
  t99 = t98 * t6;
  t101 = 0.1e1 * t99 * t15;
  t102 = t77 + t92 + t101;
  t127 = iniMatNorRB[0];
  t129 = iniMatNorRB[1];
  t131 = iniMatNorRB[2];
  t106 = t127 * t59 + t129 * t68 + t131 * t72;
  t107 = t102 * t106;
  t108 = t75 * t15;
  t112 = -0.1e1 * t108 + 0.1e1 * t99 * t9;
  t116 = -t127 * t61 + t129 * t94 + t131 * t96;
  t119 = 0.1e1 * t75 * t12;
  t122 = t119 - 0.1e1 * t90 * t9;
  t126 = t127 * t78 + t129 * t83 + t131 * t87;
  t132 = 0.1e1 * t90 * t15 - 0.1e1 * t99 * t12;
  t133 = t132 * t106;
  t136 = t112 * t126 + t116 * t122 + t133;
  t137 = 0.1e1 + t77 + t92 + t101;
  t138 = 0.1e1 / t137;
  t139 = t136 * t138;
  t141 = t112 * t116 - t122 * t126 + t132 * t139 + t107;
  t143 = sin(rtx);
  t146 = t112 * t106;
  t148 = t102 * t116 + t122 * t139 + t126 * t132 - t146;
  t153 = t122 * t106;
  t155 = t102 * t126 + t112 * t139 - t116 * t132 + t153;
  t160 = t6 * t9;
  t168 = 0.1e1 - t56;
  t169 = (0.1e1 * t160 * t141 + 0.1e1 * t7 * t155 + 0.1e1 * t47 * t148) * t168;
  t172 = t56 * t141 + t143 * (0.1e1 * t7 * t148 - 0.1e1 * t47 * t155) + 0.1e1 * t169 * t160;
  t180 = t17 * t43 + t23 * t42 + t29 * t49 - t37 * t46;
  t183 = -0.1e1 * t160 * t44 + 0.1e1 * t47 * t180;
  t193 = t56 * t155 + t143 * (-0.1e1 * t160 * t148 + 0.1e1 * t47 * t141) + 0.1e1 * t169 * t7;
  t199 = 0.1e1 * t160 * t52 - 0.1e1 * t7 * t180;
  t209 = t56 * t148 + t143 * (0.1e1 * t160 * t155 - 0.1e1 * t7 * t141) + 0.1e1 * t169 * t47;
  t211 = t172 * t55 + t183 * t193 + t199 * t209;
  t215 = t172 * t180 + t193 * t52 + t209 * t44;
  t216 = atan2(t211, t215);
  t219 = 0.1e1 / hL0;
  t221 = t6 / t4;
  t222 = t221 * t12;
  t223 = t44 * t9;
  t225 = 0.1e1 * t222 * t223;
  t226 = t18 * t221;
  t229 = 0.1e1 * t8;
  t230 = t20 * t221;
  t231 = t12 * t9;
  t233 = 0.1e1 * t230 * t231;
  t234 = t22 * t221;
  t235 = t15 * t9;
  t237 = 0.1e1 * t234 * t235;
  t238 = -0.1e1 * t226 * t1 + t229 - t233 - t237;
  t241 = 0.1e1 * t230 * t235;
  t243 = 0.1e1 * t234 * t231;
  t244 = -t241 + t243;
  t247 = 0.1e1 * t226 * t235;
  t250 = 0.1e1 * t14;
  t251 = t247 - 0.1e1 * t234 * t1 + t250;
  t256 = 0.1e1 * t226 * t231;
  t259 = 0.1e1 * t11;
  t260 = -t256 + 0.1e1 * t230 * t1 - t259;
  t263 = (t244 * t43 + t251 * t46 + t260 * t49) * t41;
  t265 = t40 * t40;
  t267 = t39 / t265;
  t287 = t238 * t267;
  t271 = t238 * t49 + t244 * t46 - t251 * t43 + t260 * t42 + t263 * t37 - t287 * t37;
  t274 = t221 * t15;
  t275 = t52 * t9;
  t277 = 0.1e1 * t274 * t275;
  t285 = t238 * t46 - t244 * t49 + t251 * t42 + t260 * t43 + t263 * t29 - t287 * t29;
  t288 = -t225 + 0.1e1 * t7 * t271 + t277 - 0.1e1 * t47 * t285;
  t290 = t74 * t221;
  t293 = 0.1e1 * t75;
  t294 = t89 * t221;
  t296 = 0.1e1 * t294 * t231;
  t297 = t98 * t221;
  t299 = 0.1e1 * t297 * t235;
  t300 = -0.1e1 * t290 * t1 + t293 - t296 - t299;
  t303 = 0.1e1 * t290 * t235;
  t306 = 0.1e1 * t99;
  t307 = t303 - 0.1e1 * t297 * t1 + t306;
  t310 = 0.1e1 * t290 * t231;
  t313 = 0.1e1 * t90;
  t314 = -t310 + 0.1e1 * t294 * t1 - t313;
  t317 = 0.1e1 * t294 * t235;
  t319 = 0.1e1 * t297 * t231;
  t320 = -t317 + t319;
  t325 = (t106 * t320 + t116 * t314 + t126 * t307) * t138;
  t327 = t137 * t137;
  t328 = 0.1e1 / t327;
  t329 = t136 * t328;
  t333 = -t132 * t300 * t329 + t106 * t300 + t116 * t307 - t126 * t314 + t132 * t325 + t139 * t320;
  t335 = t148 * t9;
  t337 = 0.1e1 * t222 * t335;
  t345 = -t122 * t300 * t329 - t106 * t307 + t116 * t300 + t122 * t325 + t126 * t320 + t139 * t314;
  t348 = t155 * t9;
  t350 = 0.1e1 * t274 * t348;
  t358 = -t112 * t300 * t329 + t106 * t314 + t112 * t325 - t116 * t320 + t126 * t300 + t139 * t307;
  t363 = t221 * t1;
  t367 = 0.1e1 * t6 * t141;
  t371 = 0.1e1 * t222 * t348;
  t375 = 0.1e1 * t274 * t335;
  t379 = (-0.1e1 * t363 * t141 + t367 + 0.1e1 * t160 * t333 - t371 + 0.1e1 * t7 * t358 - t375 + 0.1e1 * t47 * t345) * t168;
  t385 = 0.1e1 * t169 * t6;
  t386 = t56 * t333 + t143 * (-t337 + 0.1e1 * t7 * t345 + t350 - 0.1e1 * t47 * t358) + 0.1e1 * t379 * t160 - 0.1e1 * t169 * t363 + t385;
  t391 = 0.1e1 * t6 * t44;
  t394 = t180 * t9;
  t396 = 0.1e1 * t274 * t394;
  t404 = -t23 * t238 * t267 + t23 * t263 + t238 * t43 + t244 * t42 + t251 * t49 - t260 * t46;
  t407 = 0.1e1 * t363 * t44 - t391 - 0.1e1 * t160 * t271 - t396 + 0.1e1 * t47 * t404;
  t413 = 0.1e1 * t6 * t148;
  t416 = t141 * t9;
  t418 = 0.1e1 * t274 * t416;
  t425 = t222 * t9;
  t427 = 0.1e1 * t425 * t169;
  t428 = t56 * t358 + t143 * (0.1e1 * t363 * t148 - t413 - 0.1e1 * t160 * t345 - t418 + 0.1e1 * t47 * t333) + 0.1e1 * t379 * t7 - t427;
  t433 = 0.1e1 * t6 * t52;
  t437 = 0.1e1 * t222 * t394;
  t440 = -0.1e1 * t363 * t52 + t433 + 0.1e1 * t160 * t285 + t437 - 0.1e1 * t7 * t404;
  t446 = 0.1e1 * t6 * t155;
  t450 = 0.1e1 * t222 * t416;
  t457 = t274 * t9;
  t459 = 0.1e1 * t169 * t457;
  t460 = t56 * t345 + t143 * (-0.1e1 * t363 * t155 + t446 + 0.1e1 * t160 * t358 + t450 - 0.1e1 * t7 * t333) + 0.1e1 * t379 * t47 - t459;
  t463 = 0.1e1 / t215;
  t465 = t211 * t211;
  t466 = t215 * t215;
  t467 = 0.1e1 / t466;
  t470 = 0.1e1 / (t465 * t467 + 0.1e1);
  t480 = t467 * t470;
  t486 = t138 * t132;
  t487 = cos(thetax);
  t489 = sin(thetax);
  t497 = 0.1e1 * t160 * t180 + 0.1e1 * t7 * t52 + 0.1e1 * t47 * t44;
  t498 = 0.1e1 - t487;
  t499 = t497 * t498;
  t502 = t487 * t44 + t489 * t199 + 0.1e1 * t499 * t47;
  t509 = t487 * t52 + t489 * t183 + 0.1e1 * t499 * t7;
  t510 = t47 * t509;
  t512 = 0.1e1 * t7 * t502 - 0.1e1 * t510;
  t515 = t138 * t112;
  t522 = t487 * t180 + t489 * t55 + 0.1e1 * t499 * t160;
  t523 = t47 * t522;
  t525 = -0.1e1 * t160 * t502 + 0.1e1 * t523;
  t528 = t138 * t122;
  t533 = 0.1e1 * t160 * t509 - 0.1e1 * t7 * t522;
  t537 = bKh * (0.2e1 * t486 * t512 + 0.2e1 * t515 * t525 + 0.2e1 * t528 * t533);
  t538 = t328 * t132;
  t542 = t138 * t320;
  t547 = 0.1e1 * t222 * t502 * t9;
  t553 = 0.1e1 * t6 * t180;
  t557 = 0.1e1 * t222 * t275;
  t561 = 0.1e1 * t274 * t223;
  t565 = (-0.1e1 * t363 * t180 + t553 + 0.1e1 * t160 * t404 - t557 + 0.1e1 * t7 * t285 - t561 + 0.1e1 * t47 * t271) * t498;
  t569 = 0.1e1 * t499 * t457;
  t570 = t487 * t271 + t489 * t440 + 0.1e1 * t565 * t47 - t569;
  t575 = 0.1e1 * t274 * t509 * t9;
  t581 = 0.1e1 * t499 * t425;
  t582 = t487 * t285 + t489 * t407 + 0.1e1 * t565 * t7 - t581;
  t588 = t328 * t112;
  t592 = t138 * t307;
  t598 = 0.1e1 * t6 * t502;
  t601 = t522 * t9;
  t611 = 0.1e1 * t499 * t6;
  t612 = t487 * t404 + t489 * t288 + 0.1e1 * t565 * t160 - 0.1e1 * t499 * t363 + t611;
  t618 = t328 * t122;
  t622 = t138 * t314;
  t628 = 0.1e1 * t6 * t509;
  t647 = bKw * (-0.2e1 * t486 * t522 - 0.2e1 * t515 * t509 - 0.2e1 * t528 * t502);
  t675 = t221 * t2;
  t680 = t15 * t12;
  t682 = 0.1e1 * t234 * t680;
  t683 = -t256 - 0.1e1 * t230 * t2 + t259 - t682;
  t686 = 0.1e1 * t230 * t680;
  t689 = -t686 + 0.1e1 * t234 * t2 - t250;
  t692 = 0.1e1 * t226 * t680;
  t693 = t692 - t243;
  t699 = -0.1e1 * t226 * t2 + t229 + t233;
  t702 = (t43 * t689 + t46 * t693 + t49 * t699) * t41;
  t604 = t267 * t37;
  t707 = t37 * t702 + t42 * t699 - t43 * t693 + t46 * t689 + t49 * t683 - t604 * t683;
  t712 = 0.1e1 * t274 * t52 * t12;
  t615 = t267 * t29;
  t720 = t29 * t702 + t42 * t693 + t43 * t699 + t46 * t683 - t49 * t689 - t615 * t683;
  t723 = -0.1e1 * t675 * t44 + t391 + 0.1e1 * t7 * t707 + t712 - 0.1e1 * t47 * t720;
  t728 = 0.1e1 * t297 * t680;
  t729 = -t310 - 0.1e1 * t294 * t2 + t313 - t728;
  t732 = 0.1e1 * t290 * t680;
  t733 = t732 - t319;
  t737 = -0.1e1 * t290 * t2 + t293 + t296;
  t740 = 0.1e1 * t294 * t680;
  t743 = -t740 + 0.1e1 * t297 * t2 - t306;
  t748 = (t106 * t743 + t116 * t737 + t126 * t733) * t138;
  t644 = t132 * t329;
  t753 = t106 * t729 + t116 * t733 - t126 * t737 + t132 * t748 + t139 * t743 - t644 * t729;
  t652 = t122 * t329;
  t764 = -t106 * t733 + t116 * t729 + t122 * t748 + t126 * t743 + t139 * t737 - t652 * t729;
  t769 = 0.1e1 * t274 * t155 * t12;
  t661 = t112 * t329;
  t777 = t106 * t737 + t112 * t748 - t116 * t743 + t126 * t729 + t139 * t733 - t661 * t729;
  t790 = 0.1e1 * t274 * t148 * t12;
  t794 = (-t450 + 0.1e1 * t160 * t753 - 0.1e1 * t675 * t155 + t446 + 0.1e1 * t7 * t777 - t790 + 0.1e1 * t47 * t764) * t168;
  t797 = t56 * t753 + t143 * (-0.1e1 * t675 * t148 + t413 + 0.1e1 * t7 * t764 + t769 - 0.1e1 * t47 * t777) + 0.1e1 * t794 * t160 - t427;
  t803 = 0.1e1 * t274 * t180 * t12;
  t701 = t23 * t267;
  t811 = t23 * t702 + t42 * t689 + t43 * t683 - t46 * t699 + t49 * t693 - t683 * t701;
  t814 = t225 - 0.1e1 * t160 * t707 - t803 + 0.1e1 * t47 * t811;
  t821 = 0.1e1 * t274 * t141 * t12;
  t830 = t56 * t777 + t143 * (t337 - 0.1e1 * t160 * t764 - t821 + 0.1e1 * t47 * t753) + 0.1e1 * t794 * t7 - 0.1e1 * t169 * t675 + t385;
  t838 = -t557 + 0.1e1 * t160 * t720 + 0.1e1 * t675 * t180 - t553 - 0.1e1 * t7 * t811;
  t851 = t274 * t12;
  t853 = 0.1e1 * t169 * t851;
  t854 = t56 * t764 + t143 * (-t371 + 0.1e1 * t160 * t777 + 0.1e1 * t675 * t141 - t367 - 0.1e1 * t7 * t753) + 0.1e1 * t794 * t47 - t853;
  t875 = t138 * t743;
  t890 = 0.1e1 * t274 * t44 * t12;
  t894 = (-t437 + 0.1e1 * t160 * t811 - 0.1e1 * t675 * t52 + t433 + 0.1e1 * t7 * t720 - t890 + 0.1e1 * t47 * t707) * t498;
  t898 = 0.1e1 * t499 * t851;
  t899 = t487 * t707 + t489 * t838 + 0.1e1 * t894 * t47 - t898;
  t902 = t509 * t12;
  t911 = t487 * t720 + t489 * t814 + 0.1e1 * t894 * t7 - 0.1e1 * t499 * t675 + t611;
  t920 = t138 * t733;
  t927 = 0.1e1 * t274 * t522 * t12;
  t932 = t487 * t811 + t489 * t723 + 0.1e1 * t894 * t160 - t581;
  t941 = t138 * t737;
  t944 = t221 * t9;
  t952 = 0.1e1 * t6 * t522;
  t989 = -t247 - t686 - 0.1e1 * t234 * t3 + t250;
  t993 = -0.1e1 * t230 * t3 + t259 + t682;
  t997 = 0.1e1 * t226 * t3 - t229 - t237;
  t1001 = -t692 + t241;
  t1004 = (t1001 * t49 + t43 * t993 + t46 * t997) * t41;
  t1009 = t1001 * t42 + t1004 * t37 - t43 * t997 + t46 * t993 + t49 * t989 - t604 * t989;
  t1012 = t221 * t3;
  t1022 = t1001 * t43 + t1004 * t29 + t42 * t997 + t46 * t989 - t49 * t993 - t615 * t989;
  t1025 = -t890 + 0.1e1 * t7 * t1009 + 0.1e1 * t1012 * t52 - t433 - 0.1e1 * t47 * t1022;
  t1029 = -t303 - t740 - 0.1e1 * t297 * t3 + t306;
  t1033 = 0.1e1 * t290 * t3 - t293 - t299;
  t1035 = -t732 + t317;
  t1039 = -0.1e1 * t294 * t3 + t313 + t728;
  t1044 = (t1033 * t126 + t1035 * t116 + t1039 * t106) * t138;
  t1049 = -t1029 * t132 * t329 + t1029 * t106 + t1033 * t116 - t1035 * t126 + t1039 * t139 + t1044 * t132;
  t1058 = -t1029 * t122 * t329 + t1029 * t116 - t1033 * t106 + t1035 * t139 + t1039 * t126 + t1044 * t122;
  t1070 = -t1029 * t112 * t329 + t1029 * t126 + t1033 * t139 + t1035 * t106 - t1039 * t116 + t1044 * t112;
  t1084 = (-t418 + 0.1e1 * t160 * t1049 - t769 + 0.1e1 * t7 * t1070 - 0.1e1 * t1012 * t148 + t413 + 0.1e1 * t47 * t1058) * t168;
  t1087 = t56 * t1049 + t143 * (-t790 + 0.1e1 * t7 * t1058 + 0.1e1 * t1012 * t155 - t446 - 0.1e1 * t47 * t1070) + 0.1e1 * t1084 * t160 - t459;
  t1100 = -t1001 * t46 + t1004 * t23 + t42 * t993 + t43 * t989 + t49 * t997 - t701 * t989;
  t1103 = t561 - 0.1e1 * t160 * t1009 - 0.1e1 * t1012 * t180 + t553 + 0.1e1 * t47 * t1100;
  t1116 = t56 * t1070 + t143 * (t375 - 0.1e1 * t160 * t1058 - 0.1e1 * t1012 * t141 + t367 + 0.1e1 * t47 * t1049) + 0.1e1 * t1084 * t7 - t853;
  t1122 = -t277 + 0.1e1 * t160 * t1022 + t803 - 0.1e1 * t7 * t1100;
  t1135 = t56 * t1058 + t143 * (-t350 + 0.1e1 * t160 * t1070 + t821 - 0.1e1 * t7 * t1049) + 0.1e1 * t1084 * t47 - 0.1e1 * t169 * t1012 + t385;
  t1156 = t138 * t1039;
  t1159 = t502 * t15;
  t1173 = (-t396 + 0.1e1 * t160 * t1100 - t712 + 0.1e1 * t7 * t1022 - 0.1e1 * t1012 * t44 + t391 + 0.1e1 * t47 * t1009) * t498;
  t1178 = t487 * t1009 + t489 * t1122 + 0.1e1 * t1173 * t47 - 0.1e1 * t499 * t1012 + t611;
  t1187 = t487 * t1022 + t489 * t1103 + 0.1e1 * t1173 * t7 - t898;
  t1196 = t138 * t1033;
  t1209 = t487 * t1100 + t489 * t1025 + 0.1e1 * t1173 * t160 - t569;
  t1218 = t138 * t1035;
  t1260 = (t100 * t72 - t104 * t68) * t6;
  t1266 = (t100 * t87 - t104 * t83) * t6;
  t1272 = (t100 * t96 - t104 * t94) * t6;
  t1275 = 0.1e1 * t1260 * t9 + 0.1e1 * t1266 * t12 + 0.1e1 * t1272 * t15;
  t1279 = t129 * t72 - t131 * t68;
  t1285 = -0.1e1 * t1260 * t15 + 0.1e1 * t1272 * t9;
  t1289 = t129 * t96 - t131 * t94;
  t1295 = 0.1e1 * t1260 * t12 - 0.1e1 * t1266 * t9;
  t1299 = t129 * t87 - t131 * t83;
  t1305 = 0.1e1 * t1266 * t15 - 0.1e1 * t1272 * t12;
  t1313 = (t106 * t1305 + t112 * t1299 + t116 * t1295 + t122 * t1289 + t126 * t1285 + t1279 * t132) * t138;
  t1318 = -t1275 * t132 * t329 + t102 * t1279 + t106 * t1275 + t112 * t1289 + t116 * t1285 - t122 * t1299 - t126 * t1295 + t1305 * t139 + t1313 * t132;
  t1330 = -t122 * t1275 * t329 + t102 * t1289 - t106 * t1285 - t112 * t1279 + t116 * t1275 + t122 * t1313 + t126 * t1305 + t1295 * t139 + t1299 * t132;
  t1343 = -t112 * t1275 * t329 + t102 * t1299 + t106 * t1295 + t112 * t1313 - t116 * t1305 + t122 * t1279 + t126 * t1275 + t1285 * t139 - t1289 * t132;
  t1355 = (0.1e1 * t160 * t1318 + 0.1e1 * t7 * t1343 + 0.1e1 * t47 * t1330) * t168;
  t1358 = t56 * t1318 + t143 * (0.1e1 * t7 * t1330 - 0.1e1 * t47 * t1343) + 0.1e1 * t1355 * t160;
  t1369 = t56 * t1343 + t143 * (-0.1e1 * t160 * t1330 + 0.1e1 * t47 * t1318) + 0.1e1 * t1355 * t7;
  t1380 = t56 * t1330 + t143 * (0.1e1 * t160 * t1343 - 0.1e1 * t7 * t1318) + 0.1e1 * t1355 * t47;
  t1398 = t138 * t1305;
  t1404 = t138 * t1285;
  t1410 = t138 * t1295;
  t1437 = t63 * t100;
  t1439 = t66 * t104;
  t1442 = (t1437 * t59 + t1439 * t59 - t62 * t95) * t6;
  t1449 = (t1437 * t78 + t1439 * t78 - t80 * t95) * t6;
  t1453 = t61 * t63;
  t1455 = t61 * t66;
  t1458 = (-t100 * t1453 - t104 * t1455 - t58 * t95) * t6;
  t1461 = 0.1e1 * t1442 * t9 + 0.1e1 * t1449 * t12 + 0.1e1 * t1458 * t15;
  t1464 = t63 * t129;
  t1466 = t66 * t131;
  t1468 = -t127 * t62 + t1464 * t59 + t1466 * t59;
  t1474 = -0.1e1 * t1442 * t15 + 0.1e1 * t1458 * t9;
  t1479 = -t127 * t58 - t129 * t1453 - t131 * t1455;
  t1485 = 0.1e1 * t1442 * t12 - 0.1e1 * t1449 * t9;
  t1490 = -t127 * t80 + t1464 * t78 + t1466 * t78;
  t1496 = 0.1e1 * t1449 * t15 - 0.1e1 * t12 * t1458;
  t1504 = (t106 * t1496 + t112 * t1490 + t116 * t1485 + t122 * t1479 + t126 * t1474 + t132 * t1468) * t138;
  t1509 = -t132 * t1461 * t329 + t102 * t1468 + t106 * t1461 + t112 * t1479 + t116 * t1474 - t122 * t1490 - t126 * t1485 + t132 * t1504 + t139 * t1496;
  t1521 = -t122 * t1461 * t329 + t102 * t1479 - t106 * t1474 - t112 * t1468 + t116 * t1461 + t122 * t1504 + t126 * t1496 + t132 * t1490 + t139 * t1485;
  t1534 = -t112 * t1461 * t329 + t102 * t1490 + t106 * t1485 + t112 * t1504 - t116 * t1496 + t122 * t1468 + t126 * t1461 - t132 * t1479 + t139 * t1474;
  t1546 = (0.1e1 * t160 * t1509 + 0.1e1 * t7 * t1534 + 0.1e1 * t47 * t1521) * t168;
  t1549 = t56 * t1509 + t143 * (0.1e1 * t7 * t1521 - 0.1e1 * t47 * t1534) + 0.1e1 * t1546 * t160;
  t1560 = t56 * t1534 + t143 * (-0.1e1 * t160 * t1521 + 0.1e1 * t47 * t1509) + 0.1e1 * t1546 * t7;
  t1571 = t56 * t1521 + t143 * (0.1e1 * t160 * t1534 - 0.1e1 * t7 * t1509) + 0.1e1 * t1546 * t47;
  t1589 = t138 * t1496;
  t1595 = t138 * t1474;
  t1601 = t138 * t1485;
  t1629 = -t89;
  t1630 = t1629 * t6;
  t1633 = 0.1e1 * t1630 * t9 + t119;
  t1637 = -t126;
  t1639 = t15 * t116;
  t1644 = 0.1e1 * t1630 * t12 - t77;
  t1646 = t15 * t106;
  t1650 = t15 * t126;
  t1655 = (0.1e1 * t75 * t1646 + t132 * t1637 - 0.1e1 * t1630 * t1650 + t146 + t1644 * t116) * t138;
  t1661 = t1633 * t106 + t102 * t1637 - 0.1e1 * t1630 * t1639 - t1644 * t126 - t153 + t1655 * t132 - t644 * t1633 + 0.1e1 * t139 * t108;
  t1673 = t1633 * t116 + 0.1e1 * t75 * t1650 + t133 + 0.1e1 * t1630 * t1646 - t112 * t1637 + t1655 * t122 - t652 * t1633 + t139 * t1644;
  t1687 = t1633 * t126 + t107 - 0.1e1 * t75 * t1639 + t1644 * t106 + t122 * t1637 + t1655 * t112 - t661 * t1633 - 0.1e1 * t139 * t1630 * t15;
  t1699 = (0.1e1 * t160 * t1661 + 0.1e1 * t7 * t1687 + 0.1e1 * t47 * t1673) * t168;
  t1702 = t56 * t1661 + t143 * (0.1e1 * t7 * t1673 - 0.1e1 * t47 * t1687) + 0.1e1 * t1699 * t160;
  t1713 = t56 * t1687 + t143 * (-0.1e1 * t160 * t1673 + 0.1e1 * t47 * t1661) + 0.1e1 * t1699 * t7;
  t1724 = t56 * t1673 + t143 * (0.1e1 * t160 * t1687 - 0.1e1 * t7 * t1661) + 0.1e1 * t1699 * t47;
  t1742 = t138 * t74;
  t1749 = t138 * t1629;
  t1756 = t138 * t1644;
  t1786 = t497 * t489;
  t1789 = -t489 * t44 + t487 * t199 + 0.1e1 * t1786 * t47;
  t1796 = -t489 * t52 + t487 * t183 + 0.1e1 * t1786 * t7;
  t1808 = -t489 * t180 + t487 * t55 + 0.1e1 * t1786 * t160;
  t1292 = tK * (thetax + rtx - t216) * t219;
  t1319 = t538 * t512;
  t1332 = t588 * t525;
  t1349 = t618 * t533;
  t1370 = t538 * t522;
  t1377 = t588 * t509;
  t1385 = t618 * t502;
  energyGradient[0] = 0.1000000000e1 * t1292 * (-(t172 * t288 + t183 * t428 + t193 * t407 + t199 * t460 + t209 * t440 + t386 * t55) * t463 * t470 + (t172 * t404 + t180 * t386 + t193 * t285 + t209 * t271 + t428 * t52 + t44 * t460) * t211 * t480) + (t537 * (-0.2e1 * t1319 * t300 + 0.2e1 * t542 * t512 + 0.2e1 * t486 * (-t547 + 0.1e1 * t7 * t570 + t575 - 0.1e1 * t47 * t582) - 0.2e1 * t1332 * t300 + 0.2e1 * t592 * t525 + 0.2e1 * t515 * (0.1e1 * t363 * t502 - t598 - 0.1e1 * t160 * t570 - 0.1e1 * t274 * t601 + 0.1e1 * t47 * t612) - 0.2e1 * t1349 * t300 + 0.2e1 * t622 * t533 + 0.2e1 * t528 * (-0.1e1 * t363 * t509 + t628 + 0.1e1 * t160 * t582 + 0.1e1 * t222 * t601 - 0.1e1 * t7 * t612)) + t647 * (0.2e1 * t1370 * t300 - 0.2e1 * t542 * t522 - 0.2e1 * t486 * t612 + 0.2e1 * t1377 * t300 - 0.2e1 * t592 * t509 - 0.2e1 * t515 * t582 + 0.2e1 * t1385 * t300 - 0.2e1 * t622 * t502 - 0.2e1 * t528 * t570)) * t219;
  energyGradient[1] = 0.1000000000e1 * t1292 * (-(t172 * t723 + t183 * t830 + t193 * t814 + t199 * t854 + t209 * t838 + t55 * t797) * t463 * t470 + (t172 * t811 + t180 * t797 + t193 * t720 + t209 * t707 + t44 * t854 + t52 * t830) * t211 * t480) + (t537 * (-0.2e1 * t1319 * t729 + 0.2e1 * t875 * t512 + 0.2e1 * t486 * (-0.1e1 * t675 * t502 + t598 + 0.1e1 * t7 * t899 + 0.1e1 * t274 * t902 - 0.1e1 * t47 * t911) - 0.2e1 * t1332 * t729 + 0.2e1 * t920 * t525 + 0.2e1 * t515 * (t547 - 0.1e1 * t160 * t899 - t927 + 0.1e1 * t47 * t932) - 0.2e1 * t1349 * t729 + 0.2e1 * t941 * t533 + 0.2e1 * t528 * (-0.1e1 * t944 * t902 + 0.1e1 * t160 * t911 + 0.1e1 * t675 * t522 - t952 - 0.1e1 * t7 * t932)) + t647 * (0.2e1 * t1370 * t729 - 0.2e1 * t875 * t522 - 0.2e1 * t486 * t932 + 0.2e1 * t1377 * t729 - 0.2e1 * t920 * t509 - 0.2e1 * t515 * t911 + 0.2e1 * t1385 * t729 - 0.2e1 * t941 * t502 - 0.2e1 * t528 * t899)) * t219;
  energyGradient[2] = 0.1000000000e1 * t1292 * (-(t1025 * t172 + t1087 * t55 + t1103 * t193 + t1116 * t183 + t1122 * t209 + t1135 * t199) * t463 * t470 + (t1009 * t209 + t1022 * t193 + t1087 * t180 + t1100 * t172 + t1116 * t52 + t1135 * t44) * t211 * t480) + (t537 * (-0.2e1 * t1319 * t1029 + 0.2e1 * t1156 * t512 + 0.2e1 * t486 * (-0.1e1 * t222 * t1159 + 0.1e1 * t7 * t1178 + 0.1e1 * t1012 * t509 - t628 - 0.1e1 * t1187 * t47) - 0.2e1 * t1332 * t1029 + 0.2e1 * t1196 * t525 + 0.2e1 * t515 * (0.1e1 * t944 * t1159 - 0.1e1 * t160 * t1178 - 0.1e1 * t1012 * t522 + t952 + 0.1e1 * t47 * t1209) - 0.2e1 * t1349 * t1029 + 0.2e1 * t1218 * t533 + 0.2e1 * t528 * (-t575 + 0.1e1 * t160 * t1187 + t927 - 0.1e1 * t7 * t1209)) + t647 * (0.2e1 * t1370 * t1029 - 0.2e1 * t1156 * t522 - 0.2e1 * t486 * t1209 + 0.2e1 * t1377 * t1029 - 0.2e1 * t1196 * t509 - 0.2e1 * t515 * t1187 + 0.2e1 * t1385 * t1029 - 0.2e1 * t1218 * t502 - 0.2e1 * t528 * t1178)) * t219;
  energyGradient[3] = 0.1000000000e1 * t1292 * (-(t1358 * t55 + t1369 * t183 + t1380 * t199) * t463 * t470 + (t1358 * t180 + t1369 * t52 + t1380 * t44) * t211 * t480) + (t537 * (-0.2e1 * t1319 * t1275 + 0.2e1 * t1398 * t512 - 0.2e1 * t1332 * t1275 + 0.2e1 * t1404 * t525 - 0.2e1 * t1349 * t1275 + 0.2e1 * t1410 * t533) + t647 * (0.2e1 * t1370 * t1275 - 0.2e1 * t1398 * t522 + 0.2e1 * t1377 * t1275 - 0.2e1 * t1404 * t509 + 0.2e1 * t1385 * t1275 - 0.2e1 * t1410 * t502)) * t219;
  energyGradient[4] = 0.1000000000e1 * t1292 * (-(t1549 * t55 + t1560 * t183 + t1571 * t199) * t463 * t470 + (t1549 * t180 + t1560 * t52 + t1571 * t44) * t211 * t480) + (t537 * (-0.2e1 * t1319 * t1461 + 0.2e1 * t1589 * t512 - 0.2e1 * t1332 * t1461 + 0.2e1 * t1595 * t525 - 0.2e1 * t1349 * t1461 + 0.2e1 * t1601 * t533) + t647 * (0.2e1 * t1370 * t1461 - 0.2e1 * t1589 * t522 + 0.2e1 * t1377 * t1461 - 0.2e1 * t1595 * t509 + 0.2e1 * t1385 * t1461 - 0.2e1 * t1601 * t502)) * t219;
  energyGradient[5] = 0.1000000000e1 * t1292 * (-(t1702 * t55 + t1713 * t183 + t1724 * t199) * t463 * t470 + (t1702 * t180 + t1713 * t52 + t1724 * t44) * t211 * t480) + (t537 * (-0.2e1 * t1319 * t1633 + 0.2e1 * t1742 * t47 * t512 - 0.2e1 * t1332 * t1633 - 0.2e1 * t1749 * t47 * t525 - 0.2e1 * t1349 * t1633 + 0.2e1 * t1756 * t533) + t647 * (0.2e1 * t1370 * t1633 - 0.2e1 * t1742 * t523 + 0.2e1 * t1377 * t1633 + 0.2e1 * t1749 * t510 + 0.2e1 * t1385 * t1633 - 0.2e1 * t1756 * t502)) * t219;
  energyGradient[6] = 0.1000000000e1 * t1292 + (t537 * (0.2e1 * t486 * (0.1e1 * t7 * t1789 - 0.1e1 * t47 * t1796) + 0.2e1 * t515 * (-0.1e1 * t160 * t1789 + 0.1e1 * t47 * t1808) + 0.2e1 * t528 * (0.1e1 * t160 * t1796 - 0.1e1 * t7 * t1808)) + t647 * (-0.2e1 * t486 * t1808 - 0.2e1 * t515 * t1796 - 0.2e1 * t528 * t1789)) * t219;
}
